//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "D64HBCB.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma link "cspin"
#pragma resource "*.dfm"

short wTotalBoard;
Word wBoardNo;
DWord dwDOVal;
int iRtn;
BYTE bSelCardID;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   //********************************************************************
  //* NOTICE: call Ixud_DriverInit() to initialize the driver.         *
  //* Initial the device driver, and return the board number in the PC *
  //********************************************************************

    WORD wBoardIndex;
    BYTE pAvilCardNum[15];
    BYTE bCardID;

    // Driver Initialize
    iRtn = d64h_scan(&wTotalBoard,&pAvilCardNum[0]);

    btnActive->Caption = "Active";

    if ( iRtn != SUCCESS_NO_ERROR )
    {
        ShowMessage( "Driver Initial Err!!Error Code:" + IntToStr(iRtn)) ;
        btnActive->Enabled = False;
    }
    else
        btnActive->Enabled = True;


        // Get Card Information
       for (wBoardIndex = 0 ; wBoardIndex <= wTotalBoard-1 ; wBoardIndex++){

        iRtn = d64h_cardinfo_get(wBoardIndex, &bCardID);
        if (iRtn)
         {
            ShowMessage("Get Card Information Err!!Error Code:" + IntToStr(iRtn));
         }

         cbxBoardNo->Items->Add(IntToStr(wBoardIndex) + " 0x" + IntToStr(bCardID));
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnEndClick(TObject *Sender)
{
   // Driver Close

   Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnActiveClick(TObject *Sender)
{

    wBoardNo = StrToInt(cbxBoardNo->ItemIndex);

    if (StrToInt(cbxBoardNo->ItemIndex) != 0){
        ShowMessage("Select Board Err, Pls retry!!");
        return ;
    }
    if (btnActive->Caption == "Active")
    {
        btnActive->Caption   = "Stop";
        btnEnd->Enabled   = False;
        //Open Card
        iRtn = d64h_open(bSelCardID);
        CheckBox1Click( CheckBox1 );
        CheckBox1Click( CheckBox1 );
        Timer1->Enabled    = True;
        GroupBox1->Enabled = True;
    }
    else
   {
        btnActive->Caption   = "Active";
        //Open Card
        iRtn = d64h_close(bSelCardID);
        btnEnd->Enabled   = True;
        Timer1->Enabled    = False;
        GroupBox1->Enabled = False;
    };
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   int   i;
   WORD  wRetVal;
   DWORD dwDIVal;

   // Read Digital Input port Val
   //wRetVal = Ixud_ReadDI(wBoardNo, wInputPortNo, &dwDIVal);
      iRtn = d64h_di_readport(bSelCardID, &dwDIVal);
      eDIVal->Text ="0x"+IntToHex(int(dwDIVal),8);
   //if ( wRetVal != Ixud_NoErr )
   // {
   //    ShowMessage(" Read DI Err!!Error Code:" + IntToStr(wRetVal));
   //    return ;
  // };

   for (i=0;i<32;i++) {
        if (( dwDIVal & (1 << i)) != 0)
            ((TShape*)FindComponent("PSp" + IntToHex(i,2)))->Brush->Color = clRed;
        else
            ((TShape*)FindComponent("PSp" + IntToHex(i,2)))->Brush->Color = clBlack;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{

    if ( ((TCheckBox*)Sender)->Checked )
       dwDOVal = dwDOVal | (DWord)(1 << ((TCheckBox*)Sender)->Tag);
    else
       dwDOVal = dwDOVal & (DWord)( ~(1 << ((TCheckBox*)Sender)->Tag));

    // Read Digital Output port Val
    iRtn = d64h_do_writeport(bSelCardID, dwDOVal);
    eDOVal->Text ="0x"+IntToHex(int(dwDOVal),8);


}
//---------------------------------------------------------------------------

void __fastcall TForm1::cbxBoardNoChange(TObject *Sender)
{
      int PortIndex;
      int wDO,wDI;

      wBoardNo = StrToInt(cbxBoardNo->ItemIndex);

       //Get Card Info
       iRtn = d64h_cardinfo_get(wBoardNo, &bSelCardID);
       if (iRtn)
       {
            ShowMessage("Get Card Information Err!!Error Code:" + IntToStr(iRtn));
       }
}
//---------------------------------------------------------------------------


