//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "D64HBCB.h"
#include "Math.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma link "cspin"
#pragma resource "*.dfm"

#define PI 3.14159265359
#define maximum_fifo_loop_count 2048

short wTotalBoard;
Word wBoardNo;
DWord dwDISamples;
int iRtn;
BYTE bSelCardID;

DWord  dwDataNum = 40960;
DWord  DoBuf[10240];
DWord  DiBuf[40960];

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{

   //********************************************************************
   //* NOTICE: call Ixud_DriverInit() to initialize the driver.         *
   //* Initial the device driver, and return the board number in the PC *
   //********************************************************************

    WORD wBoardIndex;
    BYTE pAvilCardNum[15];
    BYTE bCardID;

    // Driver Initialize
    iRtn = d64h_scan(&wTotalBoard,&pAvilCardNum[0]);

    btnActive->Caption = "Active";

    if ( iRtn != SUCCESS_NO_ERROR )
    {
        ShowMessage( "Driver Initial Err!!Error Code:" + IntToStr(iRtn)) ;
        btnActive->Enabled = False;
    }
    else
        btnActive->Enabled = True;


        // Get Card Information
       for (wBoardIndex = 0 ; wBoardIndex <= wTotalBoard-1 ; wBoardIndex++){

        iRtn = d64h_cardinfo_get(wBoardIndex, &bCardID);
        if (iRtn)
         {
            ShowMessage("Get Card Information Err!!Error Code:" + IntToStr(iRtn));
         }

         cbxBoardNo->Items->Add(IntToStr(wBoardIndex) + " 0x" + IntToStr(bCardID));
    }

    YStart->Text = "0x0";
    YEnd->Text = "0xFFFFFFFF" ;

    ClearCanvas( Image1->Canvas , clYellow ) ;

     for (int i=0; i<10240; i++)
     {
       DoBuf[i] = (DWord)(sin((double)i/1024*PI)*0x7FFFFFFF)+0x80000000;
     }

}


void __fastcall TForm1::btnExitClick(TObject *Sender)
{
   Close();
}


//---------------------------------------------------------------------------

void __fastcall TForm1::btnActiveClick(TObject *Sender)
{
    DWord dwBufLen,dwDIBufLen,count;
    double fDOSampleRate,fDISampleRate;
    wBoardNo = StrToInt(cbxBoardNo->ItemIndex);

    if (StrToInt(cbxBoardNo->ItemIndex) != 0){
        ShowMessage("Select Board Err, Pls retry!!");
        return ;
    }

    if (btnActive->Caption == "Active")
    {
        btnActive->Caption   = "Stop";

        //Open Card
        iRtn = d64h_open(bSelCardID);

        iRtn = d64h_di_available_memory( bSelCardID, &dwBufLen );
        if( iRtn == SUCCESS_NO_ERROR )
	{
	        dwDIBufLen = ( dwBufLen * 1024 );
	}

        dwDISamples = StrToFloat(tbxDataNum->Text);

	if( ( dwDISamples * sizeof(DWord) ) > dwDIBufLen )
	{
		ShowMessage( "Too much samples to be acquired" );
		return;
	}

	iRtn = d64h_do_config( bSelCardID, TRIG_SOURCE_INT_PACER, OREQ_DISABLE, OTRIG_HIGH );
	if( iRtn != SUCCESS_NO_ERROR )
	{
		ShowMessage("d64h_do_config() failed, error code" + IntToStr(iRtn) );
		return;
	}


        iRtn = d64h_di_config( bSelCardID, TRIG_SOURCE_INT_PACER, DI_NOWAITING, DI_TRIG_RISING, IREQ_FALLING );
	if( iRtn != SUCCESS_NO_ERROR )
        {
		ShowMessage( "d64h_di_config() failed, error code " + IntToStr(iRtn) );

		return;
        }

	// enable DI double-buffer mode
        iRtn = d64h_di_async_dblbuf_mode( bSelCardID, DOUBLE_BUFFER_MODE_DISABLE );
	if( iRtn != SUCCESS_NO_ERROR )
        {
		ShowMessage( "d64h_di_async_dblbuf_mode() failed, error code" + IntToStr(iRtn) );

		return;
        }

	// Enable DO double-buffer mode
        iRtn = d64h_do_async_dblbuf_mode( bSelCardID, DOUBLE_BUFFER_MODE_DISABLE );
	if( iRtn != SUCCESS_NO_ERROR )
        {
		ShowMessage( "d64h_do_async_dblbuf_mode() failed, error code" + IntToStr(iRtn) );
		return;
        }
        /*
	dwMemSize = (m_dwDISamples * 2); // (m_dwDISamples * sizeof(U32)/2 )
	pMem = malloc( dwMemSize );
	if( pMem == NULL )
	{
	        ShowMessage( "Memory allocated failed");
		return;
	}
	else
	{
		m_pDIAddr = (U32*) pMem;
		memset( m_pDIAddr, '\0', dwMemSize );
	}   */
        fDISampleRate = StrToFloat(tbxSRate->Text)*1000;
        fDOSampleRate = fDISampleRate;
//	nErrCode = d64h_continue_writeport( m_bCardID, DoBuf, 10240, &m_fSampleRate, ASYNCH_OP);
	iRtn = d64h_continue_pattern_write( bSelCardID, DoBuf, 2048, &fDOSampleRate );
	if( iRtn != SUCCESS_NO_ERROR )
        {
	        ShowMessage( "d64h_continue_pattern_write() failed, error code = " + IntToStr(iRtn));
                return;
        }

        
        iRtn = d64h_continue_readport(bSelCardID, DiBuf, dwDISamples, &fDISampleRate, SYNCH_OP);
	if( iRtn != SUCCESS_NO_ERROR )
        {
		ShowMessage( "d64h_continue_readport() failed, error code = " + IntToStr(iRtn) );
		return;
        }

        iRtn = d64h_do_async_clear( bSelCardID, &count );
        if( iRtn != SUCCESS_NO_ERROR )
        {
		ShowMessage( "d64h_do_async_clear() failed, error code = " + IntToStr(iRtn) );
		return;
        }

        DrawWave(0.0,4294967295.0,DiBuf, DWord(dwDISamples) , Image1);

        GroupBox1->Enabled = True;

        btnActive->Caption   = "Active";
        //Close Card
        iRtn = d64h_close(bSelCardID);
        GroupBox1->Enabled = False;
    }


}

//---------------------------------------------------------------------------

//This function will Clear the specify Canvas.
void __fastcall TForm1::ClearCanvas(TCanvas* Cv, TColor cc)
{
     ((TCanvas*)Cv)->Brush->Style = bsSolid;
     ((TCanvas*)Cv)->Brush->Color = cc;
     ((TCanvas*)Cv)->FillRect(((TCanvas*)Cv)->ClipRect);

}
//---------------------------------------------------------------------------

//* -------------------------------------------------------------*//
//* Function : DrawWave                                          *//
//* Description : this function will compute the YStart , YEnd   *//
//*               , DataNo , Image's Width , Image's Height      *//
//*               to draw the appropriate wave graphicals.       *//
//* Parameter : YStart --> the Start Value (Base)                *//
//*             YEnd   --> the End Value   (Max)                 *//
//*             Buf    --> Array [ 0 .. DataNo ] of Single       *//
//*                        Store the AD value                    *//
//*             DataNo --> How many Data will be process         *//
//*             im     --> What IMAGE control will be draw on    *//
//* Return : 0 --> No error occur                                *//
//*          ? --> Error                                         *//
//*--------------------------------------------------------------*//

int  __fastcall TForm1::DrawWave(float YStart ,float YEnd, DWord* Buf, DWord DN, TImage* im)
{

   float DeltaX , DeltaY ;
   int   px , py ;
   DWord i;

   ClearCanvas( im->Canvas , clYellow ) ;   //'Clear Canvas before checking error
   lDataNo->Caption = IntToStr( DN );
   Application->ProcessMessages();

     if ( YStart >= YEnd )   //'if any error occur, user will see a white window
     {
        return 1;         //'Error : YEnd must great then YStart
     };

     DeltaX = im->Width / (float) DN ;                  //'make some margin
     DeltaY = im->Height / (float)( YEnd - YStart );
     im->Canvas->Pen->Style = psSolid ;
     im->Canvas->Pen->Color = clRed   ;
     im->Canvas->Pen->Mode  = pmCopy  ;

     px = 0;              // 'close to 0 * DeltaX
     py = (long)(( YEnd - (float)Buf[0] ) * DeltaY) ;
     im->Canvas->MoveTo(px , py);
     for (i=1;i<DN;i++)
     {
          px = (long)(i * DeltaX) ;
          py = (long)(( YEnd - (float)Buf[i] ) * DeltaY );
          im->Canvas->LineTo( px , py );
     };

     return 0;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::cbxBoardNoChange(TObject *Sender)
{
        wBoardNo = StrToInt(cbxBoardNo->ItemIndex);

       //Get Card Info
       iRtn = d64h_cardinfo_get(wBoardNo, &bSelCardID);
       if (iRtn)
       {
            ShowMessage("Get Card Information Err!!Error Code:" + IntToStr(iRtn));
       }
}
//---------------------------------------------------------------------------

